//---------------------------------------------------------------------------
#include <vcl.h>
#include <shellapi.h>
#pragma hdrstop

#include "DemoBCBf.h"
#include "uCalcCPP.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
long double H, W;
void CartesianLineTo(long double a, long double b);

void CartesianLineTo(long double a, long double b)
{
   int x, y;

   x = W * (a + 10) / 20;
   y = H * (2 - b) / 4;
   Form1->Image1->Canvas->LineTo(x, y);
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::txtExpressionChange(TObject *Sender)
{
   lblEvalSource->Caption = "Expression = \x22" + txtExpression->Text + "\x22;";
}
//---------------------------------------------------------------------------


void __fastcall TForm1::btnEvalClick(TObject *Sender)
{
   txtResult->Text = ucEvalStr(txtExpression->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnDefineClick(TObject *Sender)
{
   ucDefine(txtDefinition->Text.c_str());    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::txtDefinitionChange(TObject *Sender)
{
   lblDefineSource->Caption = "Definition = \x22" + txtDefinition->Text + "\x22;";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkExprEvalExamplesClick(TObject *Sender)
{
   ShellExecute(0, "", "CMD.EXE", "/C notepad DemoExpr.Txt", "", SW_NORMAL);    
}
//---------------------------------------------------------------------------


void __fastcall TForm1::chkDefExamplesClick(TObject *Sender)
{
   ShellExecute(0, "", "CMD.EXE", "/C notepad DemoDefs.Txt", "", SW_NORMAL);
}
//---------------------------------------------------------------------------

// uCalc callback routines
// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
long double _stdcall MyEasyCallback(double a, long& b, byte c)
{
   return a + b + c;
}

long double _stdcall MyIIF(long cond, long TruePart, long FalsePart)
{
   if (cond != 0)
   return ucEvaluate(TruePart);
   else return ucEvaluate(FalsePart);
}

char* _stdcall MyIIFStr(long cond, long TruePart, long FalsePart)
{
   if (cond != 0)
   return ucEvaluateStr(TruePart);
   else return ucEvaluateStr(FalsePart);
}

long _stdcall MyMsgBox(long Prompt, long Buttons, long Title)
{
   return Application->MessageBox(ucEvaluateStr(Prompt), ucEvaluateStr(Title), Buttons);
}

long _stdcall MyMsgBoxB(AnsiString Prompt, long Buttons, AnsiString Title)
{
   return Application->MessageBox(Prompt.c_str(), Title.c_str(), Buttons);
}

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   AnsiString Def;
   Image1->Canvas->Rectangle(0, 0, Image1->Width, Image1->Height);

   Def = "MyEasyCallback(ByVal a As Double, ByRef b As Long, ByVal c As Byte) As Extended At " + IntToStr(FuncPtr(MyEasyCallback));
   ucDefineFunction(Def.c_str());
   Def = "MyIIf(ByVal cond As Long, ByExpr TruePart, ByExpr FalsePart) As Extended At " + IntToStr(FuncPtr(MyIIF));
   ucDefineFunction(Def.c_str());
   Def = "MyIIf(ByVal cond As Long, ByExpr TruePart As String, ByExpr FalsePart As String) As String At " + IntToStr(FuncPtr(MyIIFStr));
   ucDefineFunction(Def.c_str());
   Def = "MyMsgBox(ByExpr Prompt As String, ByVal Buttons As Long = 0, ByExpr Title As String = 'uCalc') As Long At " + IntToStr(FuncPtr(MyMsgBox));
   ucDefineFunction(Def.c_str());
   Def = "MyMsgBoxB(ByRef Prompt As String, ByVal Buttons As Long = 0, ByRef Title As String = 'uCalc') As Long At " + IntToStr(FuncPtr(MyMsgBoxB));
   ucDefineFunction(Def.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnPlotClick(TObject *Sender)
{
   AnsiString VarDef;
   long double x = -10;
   DWORD EqPtr, xPtr;

   VarDef = "x As Extended At " + IntToStr((DWORD)&x);
   xPtr = ucDefineVariable(VarDef.c_str());
   EqPtr = ucParse(txtPlotEq->Text.c_str());

   Image1->Canvas->FillRect(ClientRect);

   W = Image1->Width;
   H = Image1->Height;

   Image1->Canvas->MoveTo(0, H/2);

   while (x <= 10)
   {
      CartesianLineTo(x, ucEvaluate(EqPtr));
      x = x + 0.125;
   }

   ucReleaseItem(EqPtr);
   ucReleaseItem(xPtr);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::txtExpressionKeyPress(TObject *Sender, char &Key)
{
   if (Key==13) btnEvalClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::txtPlotEqKeyPress(TObject *Sender, char &Key)
{
   if (Key==13) btnPlotClick(Sender);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnSumClick(TObject *Sender)
{
   long double x = 1, SumTotal = 0, SumMax;
   DWORD ExprPtr, xPtr;
   AnsiString VarDef;
   TDateTime TimerStart, Elapsed;
   AnsiString SecStr, MSecStr;
   Word Hour, Min, Sec, MSec;

   SumMax = StrToFloat(txtSumMax->Text);
   VarDef = "x As Extended At " + IntToStr((DWORD)&x);
   xPtr = ucDefineVariable(VarDef.c_str());
   ExprPtr = ucParse(txtSumExpression->Text.c_str());
   TimerStart = Time();

   while (x <= SumMax)
   {
      SumTotal = SumTotal + ucEvaluate(ExprPtr);
      x++;
   }

   Elapsed = Time() - TimerStart;
   DecodeTime(Elapsed, Hour, Min, Sec, MSec);
   SecStr = IntToStr(Sec);
   MSecStr = IntToStr(MSec);
   txtSumResult->Text = FormatFloat("#", SumTotal);
   lblElapsed->Caption = "Elapsed Time: " + SecStr + "." + MSecStr + " seconds";

   ucReleaseItem(ExprPtr);
   ucReleaseItem(xPtr);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkInvalidOpClick(TObject *Sender)
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_InvalidOp);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkDenormalOpClick(TObject *Sender)
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_DenormalOp);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkDivisionBy0Click(TObject *Sender)
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_ZeroDivide);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkOverflowClick(TObject *Sender)
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_Overflow);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkUnderflowClick(TObject *Sender)
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_Underflow);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkPrecisionLossClick(TObject *Sender)
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_PrecisionLoss);    
}
//---------------------------------------------------------------------------

