unit DemoDlp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellApi, ExtCtrls, StdCtrls, uCalcDlp;

type
  TForm1 = class(TForm)
    txtExpression: TEdit;
    txtDefinition: TEdit;
    txtSumMax: TEdit;
    txtSumExpression: TEdit;
    txtPlotEq: TEdit;
    txtSumResult: TEdit;
    txtResult: TEdit;
    btnEval: TButton;
    btnDefine: TButton;
    btnSum: TButton;
    btnPlot: TButton;
    lblExpression: TLabel;
    lblResult: TLabel;
    lblDefinition: TLabel;
    Label4: TLabel;
    lblSumExpression: TLabel;
    lblSumResult: TLabel;
    Image1: TImage;
    lblElapsed: TLabel;
    lbl_ExprEval: TLabel;
    lblSpeedTest: TLabel;
    lbl_UserDefs: TLabel;
    lblEqPlotter: TLabel;
    lblEvalSource2: TLabel;
    lblEvalSource: TLabel;
    lblDefineSource: TLabel;
    lblDefineSource2: TLabel;
    chkExprEvalExamples: TCheckBox;
    chkDefExamples: TCheckBox;
    lblFPU: TLabel;
    chkInvalidOp: TCheckBox;
    chkDenormalOp: TCheckBox;
    chkDivisionBy0: TCheckBox;
    chkOverflow: TCheckBox;
    chkUnderflow: TCheckBox;
    chkPrecisionLoss: TCheckBox;
    procedure btnSumClick(Sender: TObject);
    procedure btnEvalClick(Sender: TObject);
    procedure btnDefineClick(Sender: TObject);
    procedure btnPlotClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure txtExpressionChange(Sender: TObject);
    procedure txtDefinitionChange(Sender: TObject);
    procedure chkExprEvalExamplesClick(Sender: TObject);
    procedure chkDefExamplesClick(Sender: TObject);
    procedure txtExpressionKeyPress(Sender: TObject; var Key: Char);
    procedure txtPlotEqKeyPress(Sender: TObject; var Key: Char);
    procedure chkInvalidOpClick(Sender: TObject);
    procedure chkDenormalOpClick(Sender: TObject);
    procedure chkDivisionBy0Click(Sender: TObject);
    procedure chkOverflowClick(Sender: TObject);
    procedure chkUnderflowClick(Sender: TObject);
    procedure chkPrecisionLossClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  H, W: Variant; { Image1 Height and Width }

implementation

{$R *.DFM}

procedure CartesianLineTo(a: Variant; b: Variant);
var
  x, y: Integer;
begin
  x := W * (a + 10) / 20;
  y := H * (2 - b) / 4;
  Form1.Image1.Canvas.LineTo(x, y);
end;

// uCalc callback routines
// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
function MyEasyCallback(a: Double; var b: Longint; c: Byte): Extended; stdcall;
begin
   MyEasyCallback := a + b + c;
end;

function MyIIF(cond, TruePart, FalsePart: Longint): Extended; stdcall;
begin
   if cond <> 0 then MyIIF := ucEvaluate(TruePart) else MyIIF := ucEvaluate(FalsePart);
end;

function MyIIFStr(cond, TruePart, FalsePart: Longint): PChar; stdcall;
begin
   if cond <> 0 then MyIIFStr := ucEvaluateStr(TruePart) else MyIIFStr := ucEvaluateStr(FalsePart);
end;

function MyMsgBox(Prompt, Buttons, Title: Longint): Longint; stdcall;
begin
   MyMsgBox := Application.MessageBox(ucEvaluateStr(Prompt), ucEvaluateStr(Title), Buttons);
end;

function MyMsgBoxB(var Prompt: AnsiString; Buttons: Longint; var Title: AnsiString): Longint; stdcall;
begin
   MyMsgBoxB := Application.MessageBox(PChar(Prompt), PChar(Title), Buttons);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   ucDefineFunction('MyEasyCallback(ByVal a As Double, ByRef b As Long, ByVal c As Byte) As Extended At ' + IntToStr(Longword(@MyEasyCallback)));
   ucDefineFunction('MyIIf(ByVal cond As Long, ByExpr TruePart, ByExpr FalsePart) As Extended At ' + IntToStr(Longword(@MyIIF)));
   ucDefineFunction('MyIIf(ByVal cond As Long, ByExpr TruePart As String, ByExpr FalsePart As String) As String At ' + IntToStr(Longword(@MyIIFStr)));
   ucDefineFunction('MyMsgBox(ByExpr Prompt As String, ByVal Buttons As Long = 0, ByExpr Title As String = "uCalc") As Long At ' + IntToStr(Longword(@MyMsgBox)));
   ucDefineFunction('MyMsgBoxB(ByRef Prompt As String, ByVal Buttons As Long = 0, ByRef Title As String = "uCalc") As Long At ' + IntToStr(Longword(@MyMsgBoxB)));

   Image1.Canvas.Rectangle(0, 0, Image1.Width, Image1.Height);
end;

procedure TForm1.btnSumClick(Sender: TObject);
var
   ExprPtr, xPtr: Longword;
   x, SumMax, SumTotal: Extended;
   Code: Integer;
   TimerStart, Elapsed: TDateTime;
   HourStr, MSecStr: string;
   Hour, Min, Sec, MSec: Word;
begin   
   x := 1;
   SumTotal := 0;

   xPtr := ucDefineVariable('x As Extended At ' + FloatToStr(Longword(@x)));
   ExprPtr := ucParse(txtSumExpression.Text);

   val(txtSumMax.Text, SumMax, Code);
   TimerStart := Time;   

   while x <= SumMax do
   begin
     SumTotal := SumTotal + ucEvaluate(ExprPtr);
     x := x + 1;
   end;

   Elapsed := Time - TimerStart;
   DecodeTime(Elapsed, Hour, Min, Sec, MSec);
   Str(Sec, HourStr);
   Str(MSec, MSecStr);

   lblElapsed.Caption := 'Elapsed Time: ' + HourStr + '.' + MSecStr + ' seconds';
   txtSumResult.Text  := FormatFloat('#', SumTotal);
   
   ucReleaseItem(ExprPtr);
   ucReleaseItem(xPtr);
end;

procedure TForm1.btnEvalClick(Sender: TObject);
begin
   txtResult.Text := ucEvalStr(txtExpression.Text);
end;

procedure TForm1.btnDefineClick(Sender: TObject);
begin
   ucDefine(txtDefinition.Text);
end;

procedure TForm1.btnPlotClick(Sender: TObject);
var
   x: Extended;
   EqPtr, xPtr: Longword;
begin
   Image1.Canvas.FillRect(ClientRect);
   xPtr := ucDefineVariable('x As Extended At ' + FloatToStr(Longword(@x)));
   EqPtr := ucParse(txtPlotEq.Text);

   W := Image1.Width;
   H := Image1.Height;
   x := -10;

   Image1.Canvas.MoveTo(0, H/2);

   while x <= 10 do
   begin try
      CartesianLineTo(x, ucEvaluate(EqPtr));
   except end;
      x := x + 0.125;
   end;

   ucReleaseItem(EqPtr);
   ucReleaseItem(xPtr)
end;

procedure TForm1.txtExpressionChange(Sender: TObject);
begin
   lblEvalSource.Caption := 'Expression := ''' + txtExpression.Text + ''';';
end;

procedure TForm1.txtDefinitionChange(Sender: TObject);
begin
   lblDefineSource.Caption := 'Definition := ''' + txtDefinition.Text + ''';'
end;

procedure TForm1.chkExprEvalExamplesClick(Sender: TObject);
begin
   ShellExecute(0, nil, 'CMD.EXE', '/C notepad DemoExpr.Txt', nil, SW_NORMAL);
end;

procedure TForm1.chkDefExamplesClick(Sender: TObject);
begin
   ShellExecute(0, nil, 'CMD.EXE', '/C notepad DemoDefs.Txt', nil, SW_NORMAL);
end;

procedure TForm1.txtExpressionKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then btnEvalClick(Sender);
end;

procedure TForm1.txtPlotEqKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then btnPlotClick(Sender);
end;

procedure TForm1.chkInvalidOpClick(Sender: TObject);
begin
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_InvalidOp);
end;

procedure TForm1.chkDenormalOpClick(Sender: TObject);
begin
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_DenormalOp);
end;

procedure TForm1.chkDivisionBy0Click(Sender: TObject);
begin
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_ZeroDivide);
end;

procedure TForm1.chkOverflowClick(Sender: TObject);
begin
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_Overflow);
end;

procedure TForm1.chkUnderflowClick(Sender: TObject);
begin
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_Underflow);
end;

procedure TForm1.chkPrecisionLossClick(Sender: TObject);
begin
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_PrecisionLoss);
end;

end.
